஡
Uses Crt,Dos,Cursor,Win,MadTet;
 Label Konec;
 Const
  Bord        : Byte = $00;
  CL          : Array[1..8] of Byte = (1,9,3,11,15,11,3,9);

 Type
  Player = record
            FirstName : String[20];
            LastLev   : Byte;
            Points    : LongInt;
          end;

 Var
  Field       : Array[0..11,0..21] of Byte;
  Disp        : Array[1..25,1..80] of Word Absolute $B800:$0000;
  Disp1       : Array[1..25,1..80] of Word;
  Stat        : Array[1..7] of Word;
  Results     : Array[1..20] of Player;
  Info        : Player;
  Name        : String[20];
  HGSFile     : File of Player;
  F           : File;
  HelpF       : Text;
  I,K,T,G,Q,W,E,
  Speed,
  Level,
  LastSpeed   : Integer;
  Ch,Sh       : Char;
  X,Y,X1,Y1,
  LeftFlag,
  RightFlag   : ShortInt;
  Attr,
  Nex,
  Condition,
  Cond1,
  Cond2,
  Figure      : Byte;
  OverFlag,
  LineFlag,
  NextFlag    : Boolean;
  Cou,Key     : Word;
  TimeIntVec  : Procedure;
  Lines,Score : LongInt;

  FUNCTION FileExists(EFileName: String) : Boolean;
         { Returns True if file exists; otherwise, }
         { it returns False. Closes the file if    }
         { it exists.                              }
  Var
   FEF: file;
  Begin
   {$I-}
   Assign(FEF, EFileName);
   Reset(FEF);
   Close(FEF);
   {$I+}
   FileExists := (IOResult = 0) and
    (EFileName <> '');
  End;  { FileExists }

  PROCEDURE Checking;
  Const
   CheckSum: LongInt=79514;
  Var
   Sigma   : LongInt;
   HCH     : Char;
  Begin
    If (NOT FileExists('TITLE.SCR'))   OR
       (NOT FileExists('TETRIS2.SCR')) OR
       (NOT FileExists('TETRIS.HLP'))  Then
       Begin
        WriteLn(' ࠢ쭮 ࠡ ணࠬ 室 䠩 :');
        WriteLn(' TETRIS .EXE');
        WriteLn(' TETRIS .HLP');
        WriteLn(' TETRIS2.SCR');
        WriteLn(' TITLE  .SCR');
        Halt(0);
       End;

     Sigma:=0;

     Assign(HelpF,'TETRIS.HLP');
     Reset(HelpF);

     While NOT EOF(HelpF) do
     Begin
      Read(HelpF,HCH);
      Inc(Sigma,Ord(HCH));
     End;
     Close(HelpF);

     If Sigma <> CheckSum Then
     Begin
       Assign(HelpF,'TETRIS.HLP');
       ReWrite(HelpF);
       WriteLn(HelpF);
       WriteLn(HelpF);
       WriteLn(HelpF,
       '     䠩 ~TETRIS.HLP~ 뫠 㦥 䠪᪠ 訡 !!!');
       WriteLn(HelpF,
       '    ⥫䮭 ~(09622) 6-95-91~ ( . ஢ . .)');
       WriteLn(HelpF);
       WriteLn(HelpF,
       '                      訢 .           ');


       Close(HelpF);
     End;

     If NOT FileExists('TETRIS.HGS') Then
     Begin
       Assign(HGSFile,'TETRIS.HGS');
       Rewrite(HGSFile);

       For I:=1 to 20 do
       Begin
        Info.FirstName:='....................';
        Info.LastLev:=0;
        Info.Points :=0;
        Write(HGSFile,Info);
       End;

       Close(HGSFile);

     End;

  End; { Checking }

  PROCEDURE Shadow(SX1,SY1,SX2,SY2:Byte);
  Var
   AS,DF:Integer;

  Begin
   DF := SY2+1;
   For AS := (SX1+2) to (SX2+2) do Disp[DF,AS]:=Lo(Disp[DF,AS])+$0800;
   For AS := (SX2+1) to (SX2+2) do
   For DF := (SY1+1) to SY2 do Disp[DF,AS]:=Lo(Disp[DF,AS])+$0800;
  End; { Shadow }

  PROCEDURE Blin(BX,BY:Byte;S:String;BordCol:Byte;Pause:Integer);
   Var BLI : Integer;
  Begin
    Repeat
      For BLI := 1 to SizeOf(CL) do
        Begin
         WriteStr(BX,BY,S,CL[BLI]+BordCol*$10);
         Delay(Pause);
        End;

    Until KeyPressed;
    Sh := ReadKey;
  End;{Blin}

  PROCEDURE WriteNext(WN:Byte);
  Var
   WNI :Integer;
  Begin
   Window(4,3,18,7);
   TextBackGround(0);
   ClrScr;
   If NextFlag Then
   For WNI := 1 to 4
   do WriteChar(BlockX[Wn][1][WNI]*2+5,BlockY[Wn][1][WNI]+2,2,'',BColor[WN]);
   Window(30,3,80,22);
  End;

  PROCEDURE PrintScore;
   Var SCI:Integer;
   Begin
    TextBackGround(0);
    TextColor(14);

    GotoXY(40,2);
    Write(Score);
    GotoXY(40,3);
    Write(Level);
    GotoXY(40,4);
    Write(Lines);

    TextColor(15);
    For SCI:= 1 to 7 do
    Begin
     GotoXY(40,SCI*2+4);
     Write(Stat[SCI]);
    End;

   End;

  PROCEDURE Clear;
  Var
   ClearX,ClearY:Byte;
  Begin
     For ClearY:=1 to 21 do
         For ClearX:=1 to 10 do
             Begin
              If ClearX=0  Then Field[ClearX,ClearY]:=$F7;
              If ClearX=11 Then Field[ClearX,ClearY]:=$F5;
              If ClearY=0  Then Field[ClearX,ClearY]:=$F8;
              If ClearY=21 Then Field[ClearX,ClearY]:=$F2 else
              Field[ClearX,ClearY]:=Bord;
             End;
  End;

  PROCEDURE GoodBye;
  Begin

   Window(1,1,80,25);
   TextColor(7);
   TextBackGround(0);

   For I := 1 to 80 do
    Begin
     For T := 0 To 12 do
     For E := 1 to I do
     Disp[T*2+1,I]:=$07;

     For T := 12 DownTo 1 do
     For E := 80 DownTo I do
     Disp[T*2,81-I]:=$07;
    End;
  ClrScr;
  WriteLn;
  WriteLn('        ');
  WriteLn('        ');
  WriteLn('        ');
  WriteLn('        Űΰ');
  WriteLn('        Űΰ');
  WriteLn('        ŰŰΰΰ');
  WriteLn('        ŰŰΰΰ');
  WriteLn('        ŰŰΰ');
  WriteLn('        ŰŰŰΰ');
  WriteLn('        ŰŰΰΰ');
  WriteLn('        ŰŰΰΰ');
  WriteLn('        Űΰΰ');
  WriteLn('        Űΰ');
  WriteLn('        Űΰ');
  WriteLn('        ŰŰ');
  WriteLn('        Ű');
  WriteLn('        Ű');
  WriteLn('        ');
  WriteLn('        ');
  WriteLn('        ');
  WriteLn;
  TextColor(9);
  WriteLn('                               Play TETRIS !!!');
  CursorOn;
  TextColor(7);
  Halt(0);

  End; { GoodBye }

 PROCEDURE Help;
 Var
  HCH  : Char;
  HCol : Byte;
 Begin
  Move(Disp,Disp1,4000);
  Assign(HelpF,'TETRIS.HLP');
  Reset(HelpF);

  Window(7,2,73,23);
  Shadow(7,2,73,23);
  FrameWin(' Help ',SingleFrame,$2F,$2F);
  Window(8,3,72,22);
  TextBackGround(2);
  ClrScr;
  HCol := 15;

  While NOT EOF(HelpF) do
  Begin
   Read(HelpF,HCH);
   Case HCH of
    '~' : If HCol= 15 Then HCol := 14 Else HCol := 15;
    '#' : If HCol= 15 Then HCol := 10 Else HCol := 15;
    else Begin
           TextColor(HCol);
           Write(HCH);
         End;
   End;
  End;
  Close(HelpF);

  Repeat
   Sh := ReadKey;
   If Sh=#0 Then Sh := ReadKey;
  Until Sh <>';';

  Window(30,3,80,22);
  Move(Disp1,Disp,4000);

 End;

 PROCEDURE CopyBlock(CX,CY:ShortInt;CCond:Byte);
 Begin
 For I:=1 to 4 do
  Field[CX+BlockX[Figure][CCond][I],CY+BlockY[Figure][CCond][I]] := BColor[Figure];
 End;


  PROCEDURE Print(PX,PY:ShortInt;PCond:Byte);
  Var
   PrintX,PrintY:Byte;
  Begin
     For PrintY := 1 to 20 do
         For PrintX := 1 to 10 do
         Begin
          Attr:= Field[PrintX,PrintY];
          For I:=1 to 4 do
              If (PrintX=(PX+BlockX[Figure][PCond][I]))
              AND (PrintY=(PY+BlockY[Figure][PCond][I]))
                 Then Attr:=BColor[Figure];

	  WriteChar(PrintX*2-1,PrintY,2,'',Attr);
         End;
  End;

  FUNCTION Test(TX,TY:ShortInt;TCond:Byte) : Boolean;
  Var
   TI,TJ : Integer;
   TV,TH : ShortInt;
  Begin

  Test := TRUE;
   For TI:= 1 to 4 do
   Begin
     TH:=BlockX[Figure][TCond][TI];
     TV:=BlockY[Figure][TCond][TI];
     If (Field[TX+TH,TY+TV]<>Bord)
     OR (TX+TH>10) OR (TX+TH<1)
     OR (TY+TV>20) OR (TY+TV<1)
     Then Test := FALSE;
   End;
  End;{ Test}

  PROCEDURE Prepares;
  Begin
    Randomize;
    Clear;

    Assign(HGSFile,'TETRIS.HGS');  {  䠩 १⮢... }
    Reset(HGSFile);
    For I:=1 to 20 do
    Begin
      Read(HGSFile,Info);
      Results[I]:= Info;
    End;
 Close(HGSFile);


    Assign(F,'TETRIS2.SCR');
    Reset(F,1);
    BlockRead(F,Disp1,4000);
    Close(F);

    For I := 0 to 12 do
    Begin
     For T:= 1 to 80 do
     Disp[I*2+1,T]:=0;
     Sound((I*5+5)*(I*5+5));
     Delay(10);
    End;

    For I := 12 DownTo 1 do
    Begin
     For T:= 1 to 80 do
     Disp[I*2,T]:=0;
     Sound((I*5+5)*(I*5+5));
     Delay(10);
    End;

    For I := 0 to 12 do
    Begin
     For T:= 1 to 80 do
     Disp[I*2+1,T]:=Disp1[I*2+1,T];
     Sound((I*5+5)*(I*5+5));
     Delay(10);
    End;

    For I := 12 DownTo 1 do
    Begin
     For T:= 1 to 80 do
     Disp[I*2,T]:=Disp1[I*2,T];
     Sound((I*5+5)*(I*5+5));
     Delay(10);
    End;
    NoSound;

    Window(1,1,80,25);

    TextBackGround(7);
    GotoXY(1,25);
    TextColor(4);
    Write(' Esc');
    TextColor(0);
    Write(' 室  ணࠬ');
    TextColor(4);
    Write('  F1');
    TextColor(0);
    Write(' ଠ                                   ');
    WriteChar(80,25,1,' ',$77);


    Window(30,3,49,22);
    TextBackGround(Bord);
    ClrScr;
    Window(30,3,80,22);

    For I:= 1 to 7 do Stat[I]:=0;
    Cou := 0;
    X := 4; Y := 0;
    Figure := Random(7)+1;
    Nex := Random(7)+1;
    WriteNext(Nex);
    Condition := 1;
    Lines := 0;
    Score := 0;
    Speed := 1000-(Level*100);
    Key   := 0;
    PrintScore;

  End; { Prepares }
  
  PROCEDURE KbdPause;
  Var KbdCh:Char;
  Begin
   Repeat
    KbdCh := ReadKey;
    If KbdCh = #0  Then KbdCh := ReadKey;
    If KbdCh = #27 Then GoodBye;
    If KbdCh = ';' Then Help;
   Until KbdCh <> ';';
  End; { KbdPause }

  PROCEDURE ShowHgs;
  Begin;
    Window(19,1,19+42,2+22);
    Shadow(19,1,19+42,2+22);
    FrameWin('   ,    ! ',DoubleFrame,$71,$7F);
    TextBackGround(7);
    ClrScr;
    TextColor(14);
    WriteLn('       ...       ஢    窨');
    For I:= 1 to 20 do
     Begin
      If I=K Then TextColor(9)
      Else TextColor(0);
      GotoXY(2,I+1);
      Write(I:2);
      GotoXY(6,I+1);
      Write(Results[I].FirstName);
      GotoXY(29,I+1);
      Write(Results[I].LastLev);
      GotoXY(31,I+1);
      Write(Results[I].Points:10);
     End;
     WriteStr(1,22,'             Press any key. . .            ',$9F);
    KbdPause;
  End;{ ShowHgs }

  PROCEDURE Title;
  Begin
    CursorOff;

    Assign(F,'TITLE.SCR');
    Reset(F,1);
    BlockRead(F,Disp1,4000);
    Close(F);

    ClrScr;
    For I := 1 to 80 do
    Begin
     For T := 0 To 12 do
     For E := 1 to I do
     Disp[T*2+1,I]:=Disp1[T*2+1,I];

     For T := 12 DownTo 1 do
     For E := 80 DownTo I do
     Disp[T*2,81-I]:=Disp1[T*2,81-I];
    End;


    Blin(30,23,'Press any key. . .',0,50);
    If Sh=#0 Then Sh:=ReadKey;
    If Sh=#27 Then GoodBye;
   End; {Title}

  FUNCTION TestLine(TLY:Integer) : Boolean;
  Var
   TLX:Integer;
  Begin
   TestLine:=True;
   For TLX:=1 to 10 do If Field[TLX,TLY]=Bord Then TestLine:=False;
  End; { TestLine }

  PROCEDURE ClearLine(CLY:Integer);
  Var
   CLX:Integer;
  Begin
   For CLX:=1 to 10 do Field[CLX,CLY]:=Bord;
  End; { ClearLine }

  PROCEDURE PullDown(PDY:Integer);
  Var
   PDX,PDI:Integer;
  Begin
   For PDI := (PDY-1) DownTo 1 do
   For PDX := 1 to 10 do Field[PDX,PDI+1]:=Field[PDX,PDI];
   ClearLine(1);
  End;

  PROCEDURE RdLevel;
  Begin
   Window(20,8,60,16);
   Shadow(20,8,60,16);
   TextBackGround(7);
   TextColor(0);
   ClrScr;
   FrameWin('',DoubleFrame,$7F,$7F);
   CursorOn;
   GotoXY(3,3);
   Write(' 砫 ஢ [0..9] :');

   Repeat
    Sh:=ReadKey;
    If Sh=#0 Then Sh:=ReadKey;
    If Sh=#27 Then GoodBye;
    If Sh=';' Then
       Begin
        CursorOff;
        Help;
        Sh:=';';
        CursorOn;
        Window(21,9,59,15);
        TextBackGround(7);
        TextColor(0);
        GotoXY(37,3);
       End;
    Until Sh <> ';';
   If (Sh<'0') OR (Sh>'9') Then Sh := '5';
   Val(Sh,Level,I);
   WriteLn(Sh);
   CursorOff;
   WriteLn;
   TextColor(32);
   WriteLn('      ⥯,   ,');
   Write  ('       ⮡   !!!');
   KbdPause;

  End; { RdLevel }


  PROCEDURE GameOver;
  Var GOI : Integer;
  Begin
    For GOI := 10 to 200 do
       Begin
         Sound(GOI*GOI);
         Delay(2);
       End;
    NoSound;

    If Score > Results[20].Points Then
    Begin
      K:=0;
      Repeat Inc(K,1);
      Until Score>Results[K].Points;
      For I:= 19 DownTo K do
        Results[I+1] := Results[I];

      Window(20,8,60,16);
      Shadow(20,8,60,16);
      TextBackGround(7);
      ClrScr;
      FrameWin('',DoubleFrame,$7F,$7F);
      TextColor(0);
      GotoXY(1,2);
      WriteLn('         !  ४ !!!');
      WriteLn('              ',K,' .');
      TextColor(15);
      Window(21,13,59,13);
      TextBackGround(1);
      ClrScr;
      Write('     :');
      Window(37,13,59,13);
      CursorOn;
      ReadLn(Name);
      TextColor(31);
      Write(Name);
      CursorOff;
      If Length(Name)<20 Then
         For I:=Length(Name)+1 to 20 do
         Name:=Name+'.';
      Results[K].FirstName:=Name;
      Results[K].LastLev:=Level;
      Results[K].Points:=Score;

      Assign(HGSFile,'TETRIS.HGS');
      Rewrite(HGSFile);
      For I:=1 to 20 do Write(HGSFile,Results[I]);
      Close(HGSFile);

    End

    Else

    Begin
      K:=100;
      Window(20,7,60,17);
      Shadow(20,7,60,17);
      TextBackGround(7);
      ClrScr;
      FrameWin('',DoubleFrame,$7F,$7F);
      WriteStr(15,4,'Game  over !',$70);
      WriteStr(13,5,'( 祭 !)',$70);
      WriteStr(1,9,'           Press any key. . .          ',$9F);
      KbdPause;
    End;
  End;


  PROCEDURE Inkey;
    Begin
      Inc(Key,1);
      If Key > 700 Then
      Begin
       Inc(Level,1);
       If Level >9 Then Level:=9;
       Speed := 1000-(Level*100);
       Key:=0;
      End;
      Ch:=ReadKey;
      If Ch=#0 Then Ch := ReadKey;
      Case Ch Of

        #27         :  GoodBye;

        '7','G'     :  If Test(X-1,Y,Condition) Then Dec(X,1);

        '9','I'     :  If Test(X+1,Y,Condition)  Then Inc(X,1);

        '8','H'     :  Begin
                        Cond2:=Condition;
                        Inc(Condition,1);
                        If Condition > 4 Then Condition :=1;
                        If NOT Test(X,Y,Condition)
                        then Condition:=Cond2;
                       End;

        ' ','4','K' :  If Speed <> 0 Then
                       Begin
                        LastSpeed := Speed;
                        Speed := 0;
                        Inc(Score,5);
                       End;
            '1','O' :  Begin
                        NextFlag := NOT NextFlag;
                        WriteNext(Nex);
                       End;
                ';' :  Help;

        '6','M'     :  Begin
                        Inc(Level,1);
			If Level > 9 Then Level:=9;
			Speed := 1000-(Level*100);
			PrintScore;
                       End;

      End; { Case Ch of ... }
  End; { Inkey }

Begin
 Checking;
 Title;
 Repeat
  Level := 0;
  NextFlag := False;
  Prepares;
  RdLevel;
  NextFlag := True;
  Prepares;
  {**********************************************************}
  Repeat
    X1 := X;
    Y1 := Y;
    Cond1 := Condition;
    Print(X,Y,Condition);

   Repeat

    If Speed <> 0 Then Delay(1);
    Cou :=Cou+1;
    If Cou > Speed Then
      Begin
       If Test(X,Y+1,Condition)
        Then
          Begin
           Inc(Y,1);
           Cou:=1;
          End

         Else

         Begin
	  If Speed=0 Then Speed:= LastSpeed;
          OverFlag:=False;
          If Y<1 Then Goto Konec;
          Sound(50);
          Delay(1);
          Sound(100);
          Delay(1);
          Sound(150);
          Delay(1);
          NoSound;
           T:=21;
           Inc(Score,2*Level+10);
           If NOT NextFlag Then Inc(Score,5);
           Inc(Stat[Figure],1);
           CopyBlock(X,Y,Condition);
           Repeat
            T:=T-1;
            If TestLine(T) Then
               Begin
                 Inc(Lines,1);
                 Inc(Score,20*Level);
                 If NOT NextFlag Then Inc(Score,10);
                 ClearLine(T);
                 Print(X,Y,Condition);
                 Sound(200);
                 Delay(10);
                 Sound(400);
                 Delay(10);
                 Sound(800);
                 Delay(10);
                 PullDown(T);
                 T:=T+1;
               End;

           Until T < 1;
           NoSound;
           Print(X,Y,Condition);
           PrintScore;
           X:=4; Y:=0;
           Figure := Nex;
           Nex := Random(7)+1;
           WriteNext(Nex);
           Condition :=1;
         End;
       End;
    If KeyPressed Then Inkey;

   Until (X<>X1) OR (Y<>Y1) OR (Condition <> Cond1);

   Until 1=2;
  {**********************************************************}
  Konec:
   GameOver;
   ShowHgs;
  Until 1=2;
 End.